	cpu LMM
	.module parameters.c
	.area memory(abs)
	.org 0x3f00
_NonvolatileP::
	.byte 0,0
	.word 0,0,0,0,0
	.byte 0,0,0,0
	.word 500
	.word 500
	.word 5000
	.word 0,0,0,0,0
	.word 0,0,0,0,0
	.byte 0,0,0,0,0,0
	.word 0,0
	.word 0,0,0,0,0
	.byte 0,0
	.byte 'U,'s,'r,'D,'e,'v,'i,'c,'e,0
	.word 0,0,0,0,0
	.byte 0
	.byte 'F,'r,'a,'m,'e,0
	.word 0,0,0,0,0
	.byte 0,0,0,0,0
	.byte 'C,'h,49,0
	.word 0,0,0,0,0
	.byte 0,0,0,0,0,0,0
	.dbfile ./parameters.c
	.dbsym e NonvolatileP _NonvolatileP X
	.area lit(rom, con, rel)
	.area text(rom, con, rel)
	.dbfile ./parameters.c
	.dbfunc e cmemcpy _cmemcpy fpV
;           bsrc -> X+2
;          bdest -> X+0
;              n -> X-9
;            src -> X-7
;           dest -> X-5
_cmemcpy::
	.dbline -1
	push X
	mov X,SP
	add SP,4
	.dbline 57
; //*****************************************************************************
; //*****************************************************************************
; //  FILENAME:   parameters.c
; //  Version: 1.0, 2007/03/06
; //  Generated by Andy Kiser
; //
; //  DESCRIPTION:  Handling of Volatile / Nonvolatile parameters
; //
; //	This library allows for the following maximum number of parameters
; //		  8 Bit	: x16
; //		 16 Bit	: x16
; //		 32 Bit : x4
; //		168 Bit : x9	(Strings, 20+1 characters)
; //-----------------------------------------------------------------------------
; // Originally authored by Toradex AG. This work is now available under the terms and conditions
; // of the Creative Commons License 'Attribution CC BY', details of which can be found here:
; // http://creativecommons.org/licenses/by/3.0/
; //*****************************************************************************
; //*****************************************************************************
; #define __DEBUG
; 
; #include <m8c.h>
; #include <string.h>
; #include "parameters.h"
; #include "nonvolatile.h"
; #include "sensor.h"
; 
; // Parameters in RAM
; struct
; {
; 	BYTE		Param_8   [NUM_PARAM_8];
; 	WORD		Param_16  [NUM_PARAM_16];
; 	DWORD		Param_32  [NUM_PARAM_32];
; 	tParam_168	Param_168 [NUM_PARAM_168];
; } VolatileP;
; 
; // Parameters in Flash are stored in the area 0x3F00.0x3FFF
; // make sure to reserve this area in the custom.lnk file !
; // (-bNonvolatileP:0x3F00.0x3FFF)
; #pragma abs_address:0x3F00
; const struct
; {
; 	BYTE		Param_8   [MAX_PARAM_8];
; 	WORD		Param_16  [MAX_PARAM_16];
; 	DWORD		Param_32  [MAX_PARAM_32];
; 	tParam_168	Param_168 [NUM_PARAM_168];
; }	NonvolatileP = {{0,0},{500,500,5000},{0},{"UsrDevice","Frame","Ch1"}};
; #pragma end_abs_address	
; 
; 
; //-----------------------------------------------------------------------------
; // copy memory area from Flash to RAM
; // actually, I expected this function to be part of the <strings.h> library
; // however it is not there, so I'm implementing it here
; //-----------------------------------------------------------------------------
; const void *cmemcpy(void *dest, const void *src, size_t n)
; {
	.dbline 58
; 	BYTE *bdest = dest;
	mov A,[X-4]
	mov [X+1],A
	mov A,[X-5]
	mov [X+0],A
	.dbline 59
; 	const BYTE *bsrc  = src;
	mov A,[X-6]
	mov [X+3],A
	mov A,[X-7]
	mov [X+2],A
	xjmp L6
L5:
	.dbline 62
	.dbline 63
	mov REG[0xd0],>__r0
	mov A,[X+3]
	mov [__r1],A
	mov A,[X+2]
	push X
	mov X,[__r1]
	romx
	pop X
	mov [__r0],A
	mov A,[X+1]
	mov [__r3],A
	mov A,[X+0]
	mov REG[0xd5],A
	mov A,[__r0]
	mvi [__r3],A
	.dbline 64
	inc [X+1]
	adc [X+0],0
	.dbline 65
	inc [X+3]
	adc [X+2],0
	.dbline 66
	dec [X-8]
	sbb [X-9],0
	.dbline 67
L6:
	.dbline 61
; 
; 	while (n > 0)
	cmp [X-9],0
	jnz L5
	cmp [X-8],0
	jnz L5
X0:
	.dbline 69
; 	{
; 		*bdest = *bsrc;
; 		bdest++;
; 		bsrc++;
; 		n--;
; 	}
; 	
; 	return dest;
	mov REG[0xd0],>__r0
	mov A,[X-4]
	mov [__r1],A
	mov A,[X-5]
	mov [__r0],A
	.dbline -2
L4:
	add SP,-4
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l bsrc 2 pc
	.dbsym l bdest 0 pc
	.dbsym l n -9 i
	.dbsym l src -7 pV
	.dbsym l dest -5 pV
	.dbend
	.dbfunc e Parameters_Start _Parameters_Start fV
_Parameters_Start::
	.dbline -1
	.dbline 76
; }
; 
; //-----------------------------------------------------------------------------
; // Intialization on Powerup: Copy parameters from Flash to RAM
; //-----------------------------------------------------------------------------
; void Parameters_Start()
; {
	.dbline 77
; 	cmemcpy(VolatileP.Param_8,   (const void*)NonvolatileP.Param_8,   sizeof(VolatileP.Param_8));
	mov A,0
	push A
	mov A,3
	push A
	mov A,>_NonvolatileP
	push A
	mov A,<_NonvolatileP
	push A
	mov A,>_VolatileP
	push A
	mov A,<_VolatileP
	push A
	xcall _cmemcpy
	.dbline 78
; 	cmemcpy(VolatileP.Param_16,  (const void*)NonvolatileP.Param_16,  sizeof(VolatileP.Param_16));
	mov A,0
	push A
	mov A,6
	push A
	mov A,>_NonvolatileP+16
	push A
	mov A,<_NonvolatileP+16
	push A
	mov A,>_VolatileP+3
	push A
	mov A,<_VolatileP+3
	push A
	xcall _cmemcpy
	add SP,-12
	.dbline 79
; 	cmemcpy(VolatileP.Param_32,  (const void*)NonvolatileP.Param_32,  sizeof(VolatileP.Param_32));
	mov A,0
	push A
	mov A,4
	push A
	mov A,>_NonvolatileP+48
	push A
	mov A,<_NonvolatileP+48
	push A
	mov A,>_VolatileP+9
	push A
	mov A,<_VolatileP+9
	push A
	xcall _cmemcpy
	.dbline 80
; 	cmemcpy(VolatileP.Param_168, (const void*)NonvolatileP.Param_168, sizeof(VolatileP.Param_168));
	mov A,0
	push A
	mov A,63
	push A
	mov A,>_NonvolatileP+64
	push A
	mov A,<_NonvolatileP+64
	push A
	mov A,>_VolatileP+13
	push A
	mov A,<_VolatileP+13
	push A
	xcall _cmemcpy
	add SP,-12
	.dbline -2
	.dbline 81
; }
L8:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Set_Param_8 _Set_Param_8 fV
;          value -> X-6
;    NonVolatile -> X-5
;          index -> X-4
_Set_Param_8::
	.dbline -1
	push X
	mov X,SP
	.dbline 87
; 
; //-----------------------------------------------------------------------------
; // Setting Parameters
; //-----------------------------------------------------------------------------
; void Set_Param_8 (BYTE index, BOOL NonVolatile, BYTE value)
; {
	.dbline 88
; 	if (NonVolatile)
	cmp [X-5],0
	jz L19
	.dbline 89
; 		Flash_Modify(&NonvolatileP.Param_8[index], &value, 1);
	mov A,1
	push A
	mov REG[0xd0],>__r0
	mov [__r1],X
	sub [__r1],6
	mov A,3
	push A
	mov A,[__r1]
	push A
	mov A,[X-4]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_NonvolatileP
	adc [__r0],>_NonvolatileP
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	xcall _Flash_Modify
	add SP,-5
	mov REG[0xd0],>__r0
L19:
	.dbline 90
; 	VolatileP.Param_8[index] = value;
	mov REG[0xd0],>__r0
	mov A,[X-4]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_VolatileP
	adc [__r0],>_VolatileP
	mov A,[__r0]
	mov REG[0xd5],A
	mov A,[X-6]
	mvi [__r1],A
	.dbline -2
	.dbline 91
; }
L18:
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l value -6 c
	.dbsym l NonVolatile -5 c
	.dbsym l index -4 c
	.dbend
	.dbfunc e Set_Param_16 _Set_Param_16 fV
;          value -> X-7
;    NonVolatile -> X-5
;          index -> X-4
_Set_Param_16::
	.dbline -1
	push X
	mov X,SP
	.dbline 95
; 
; //-----------------------------------------------------------------------------
; void Set_Param_16 (BYTE index, BOOL NonVolatile, WORD value)
; {
	.dbline 96
; 	if (NonVolatile)
	cmp [X-5],0
	jz L22
	.dbline 97
; 		Flash_Modify((const BYTE*)&NonvolatileP.Param_16[index], (BYTE*)&value, 2);
	mov A,2
	push A
	mov REG[0xd0],>__r0
	mov [__r1],X
	sub [__r1],7
	mov A,3
	push A
	mov A,[__r1]
	push A
	mov A,[X-4]
	mov [__r1],A
	mov [__r0],0
	asl [__r1]
	rlc [__r0]
	add [__r1],<_NonvolatileP+16
	adc [__r0],>_NonvolatileP+16
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	xcall _Flash_Modify
	add SP,-5
	mov REG[0xd0],>__r0
L22:
	.dbline 98
; 	VolatileP.Param_16[index] = value;
	mov REG[0xd0],>__r0
	mov A,[X-4]
	mov [__r1],A
	mov [__r0],0
	asl [__r1]
	rlc [__r0]
	add [__r1],<_VolatileP+3
	adc [__r0],>_VolatileP+3
	mov A,[__r0]
	mov REG[0xd5],A
	mov A,[X-7]
	mvi [__r1],A
	mov A,[X-6]
	mvi [__r1],A
	.dbline -2
	.dbline 99
; }
L21:
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l value -7 i
	.dbsym l NonVolatile -5 c
	.dbsym l index -4 c
	.dbend
	.dbfunc e Set_Param_32 _Set_Param_32 fV
;          value -> X-9
;    NonVolatile -> X-5
;          index -> X-4
_Set_Param_32::
	.dbline -1
	push X
	mov X,SP
	.dbline 103
; 
; //-----------------------------------------------------------------------------
; void Set_Param_32 (BYTE index, BOOL NonVolatile, DWORD value)
; {
	.dbline 104
; 	if (NonVolatile)
	cmp [X-5],0
	jz L27
	.dbline 105
; 		Flash_Modify((const BYTE*)&NonvolatileP.Param_32[index], (BYTE*)&value, 4);
	mov A,4
	push A
	mov REG[0xd0],>__r0
	mov [__r1],X
	sub [__r1],9
	mov A,3
	push A
	mov A,[__r1]
	push A
	mov A,[X-4]
	mov [__r1],A
	mov [__r0],0
	asl [__r1]
	rlc [__r0]
	asl [__r1]
	rlc [__r0]
	add [__r1],<_NonvolatileP+48
	adc [__r0],>_NonvolatileP+48
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	xcall _Flash_Modify
	add SP,-5
	mov REG[0xd0],>__r0
L27:
	.dbline 106
; 	VolatileP.Param_32[index] = value;
	mov REG[0xd0],>__r0
	mov A,[X-4]
	mov [__r1],A
	mov [__r0],0
	asl [__r1]
	rlc [__r0]
	asl [__r1]
	rlc [__r0]
	add [__r1],<_VolatileP+9
	adc [__r0],>_VolatileP+9
	mov A,[__r0]
	mov REG[0xd5],A
	mov A,[X-9]
	mvi [__r1],A
	mov A,[X-8]
	mvi [__r1],A
	mov A,[X-7]
	mvi [__r1],A
	mov A,[X-6]
	mvi [__r1],A
	.dbline -2
	.dbline 107
; }
L26:
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l value -9 l
	.dbsym l NonVolatile -5 c
	.dbsym l index -4 c
	.dbend
	.dbfunc e Set_Param_168 _Set_Param_168 fV
;          value -> X-7
;    NonVolatile -> X-5
;          index -> X-4
_Set_Param_168::
	.dbline -1
	push X
	mov X,SP
	.dbline 111
; 
; //-----------------------------------------------------------------------------
; void Set_Param_168 (BYTE index, BOOL NonVolatile, tParam_168 value)
; {
	.dbline 112
; 	if (NonVolatile)
	cmp [X-5],0
	jz L32
	.dbline 113
; 		Flash_Modify((const BYTE*)&NonvolatileP.Param_168[index], (BYTE*)value, 21);
	mov A,21
	push A
	mov A,[X-7]
	push A
	mov A,[X-6]
	push A
	mov REG[0xd0],>__r0
	mov A,[X-4]
	mov [__r1],A
	mov A,0
	push A
	mov A,[__r1]
	push A
	mov A,0
	push A
	mov A,21
	push A
	xcall __mul16
	add SP,-4
	mov A,[__rX]
	mov [__r1],A
	mov A,[__rY]
	mov [__r0],A
	add [__r1],<_NonvolatileP+64
	adc [__r0],>_NonvolatileP+64
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	xcall _Flash_Modify
	add SP,-5
	mov REG[0xd0],>__r0
L32:
	.dbline 114
; 	strncpy (VolatileP.Param_168[index], value, 21);
	mov A,0
	push A
	mov A,21
	push A
	mov A,[X-7]
	push A
	mov A,[X-6]
	push A
	mov REG[0xd0],>__r0
	mov A,[X-4]
	mov [__r1],A
	mov A,0
	push A
	mov A,[__r1]
	push A
	mov A,0
	push A
	mov A,21
	push A
	xcall __mul16
	add SP,-4
	mov A,[__rX]
	mov [__r1],A
	mov A,[__rY]
	mov [__r0],A
	add [__r1],<_VolatileP+13
	adc [__r0],>_VolatileP+13
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	xcall _strncpy
	add SP,-6
	.dbline -2
	.dbline 116
; 
; }
L31:
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l value -7 pc
	.dbsym l NonVolatile -5 c
	.dbsym l index -4 c
	.dbend
	.dbfunc e Get_Param_8 _Get_Param_8 fV
;          value -> X-7
;    NonVolatile -> X-5
;          index -> X-4
_Get_Param_8::
	.dbline -1
	push X
	mov X,SP
	add SP,2
	.dbline 122
; 
; //-----------------------------------------------------------------------------
; // Reading parameters
; //-----------------------------------------------------------------------------
; void Get_Param_8 (BYTE index, BOOL NonVolatile, BYTE *value)
; {
	.dbline 123
; 	*value = NonVolatile ? NonvolatileP.Param_8[index] : VolatileP.Param_8[index];
	cmp [X-5],0
	jz L38
	mov REG[0xd0],>__r0
	mov A,[X-4]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_NonvolatileP
	adc [__r0],>_NonvolatileP
	mov A,[__r0]
	push X
	mov X,[__r1]
	romx
	pop X
	mov [X+1],A
	mov [X+0],0
	xjmp L39
L38:
	mov REG[0xd0],>__r0
	mov A,[X-4]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_VolatileP
	adc [__r0],>_VolatileP
	mov A,[__r0]
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [X+1],A
	mov [X+0],0
L39:
	mov REG[0xd0],>__r0
	mov A,[X+1]
	mov [__r0],A
	mov A,[X-6]
	mov [__r3],A
	mov A,[X-7]
	mov REG[0xd5],A
	mov A,[__r0]
	mvi [__r3],A
	.dbline -2
	.dbline 124
; }
L36:
	add SP,-2
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l value -7 pc
	.dbsym l NonVolatile -5 c
	.dbsym l index -4 c
	.dbend
	.dbfunc e Get_Param_16 _Get_Param_16 fV
;          value -> X-7
;    NonVolatile -> X-5
;          index -> X-4
_Get_Param_16::
	.dbline -1
	push X
	mov X,SP
	add SP,2
	.dbline 128
; 
; //-----------------------------------------------------------------------------
; void Get_Param_16 (BYTE index, BOOL NonVolatile, WORD *value)
; {
	.dbline 129
; 	*value = NonVolatile ? NonvolatileP.Param_16[index] : VolatileP.Param_16[index];
	cmp [X-5],0
	jz L44
	mov REG[0xd0],>__r0
	mov A,[X-4]
	mov [__r1],A
	mov [__r0],0
	asl [__r1]
	rlc [__r0]
	add [__r1],<_NonvolatileP+16
	adc [__r0],>_NonvolatileP+16
	mov A,[__r0]
	push X
	push A
	mov X,[__r1]
	romx
	mov [__r0],A
	pop A
	inc X
	adc A,0
	romx
	pop X
	mov [X+1],A
	mov A,[__r0]
	mov [X+0],A
	xjmp L45
L44:
	mov REG[0xd0],>__r0
	mov A,[X-4]
	mov [__r1],A
	mov [__r0],0
	asl [__r1]
	rlc [__r0]
	add [__r1],<_VolatileP+3
	adc [__r0],>_VolatileP+3
	mov A,[__r0]
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [X+0],A
	mvi A,[__r1]
	mov [X+1],A
L45:
	mov REG[0xd0],>__r0
	mov A,[X-6]
	mov [__r1],A
	mov A,[X-7]
	mov REG[0xd5],A
	mov A,[X+0]
	mvi [__r1],A
	mov A,[X+1]
	mvi [__r1],A
	.dbline -2
	.dbline 130
; }
L40:
	add SP,-2
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l value -7 pi
	.dbsym l NonVolatile -5 c
	.dbsym l index -4 c
	.dbend
	.dbfunc e Get_Param_32 _Get_Param_32 fV
;          value -> X-7
;    NonVolatile -> X-5
;          index -> X-4
_Get_Param_32::
	.dbline -1
	push X
	mov X,SP
	add SP,4
	.dbline 134
; 
; //-----------------------------------------------------------------------------
; void Get_Param_32 (BYTE index, BOOL NonVolatile, DWORD *value)
; {
	.dbline 135
; 	*value = NonVolatile ? NonvolatileP.Param_32[index] : VolatileP.Param_32[index];
	cmp [X-5],0
	jz L50
	mov REG[0xd0],>__r0
	mov A,[X-4]
	mov [__r1],A
	mov [__r0],0
	asl [__r1]
	rlc [__r0]
	asl [__r1]
	rlc [__r0]
	add [__r1],<_NonvolatileP+48
	adc [__r0],>_NonvolatileP+48
	mov A,[__r0]
	push X
	push A
	mov X,[__r1]
	romx
	mov [__r0],A
	pop A
	inc X
	adc A,0
	push A
	romx
	mov [__r1],A
	pop A
	inc X
	adc A,0
	push A
	romx
	mov [__r2],A
	pop A
	inc X
	adc A,0
	romx
	mov [__r3],A
	pop X
	mov A,[__r0]
	mov [X+0],A
	mov A,[__r1]
	mov [X+1],A
	mov A,[__r2]
	mov [X+2],A
	mov A,[__r3]
	mov [X+3],A
	xjmp L51
L50:
	mov REG[0xd0],>__r0
	mov A,[X-4]
	mov [__r1],A
	mov [__r0],0
	asl [__r1]
	rlc [__r0]
	asl [__r1]
	rlc [__r0]
	add [__r1],<_VolatileP+9
	adc [__r0],>_VolatileP+9
	mov A,[__r0]
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [X+0],A
	mvi A,[__r1]
	mov [X+1],A
	mvi A,[__r1]
	mov [X+2],A
	mvi A,[__r1]
	mov [X+3],A
L51:
	mov REG[0xd0],>__r0
	mov A,[X-6]
	mov [__r1],A
	mov A,[X-7]
	mov REG[0xd5],A
	mov A,[X+0]
	mvi [__r1],A
	mov A,[X+1]
	mvi [__r1],A
	mov A,[X+2]
	mvi [__r1],A
	mov A,[X+3]
	mvi [__r1],A
	.dbline -2
	.dbline 136
; }
L46:
	add SP,-4
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l value -7 pl
	.dbsym l NonVolatile -5 c
	.dbsym l index -4 c
	.dbend
	.dbfunc e Get_Param_168 _Get_Param_168 fV
;          value -> X-7
;    NonVolatile -> X-5
;          index -> X-4
_Get_Param_168::
	.dbline -1
	push X
	mov X,SP
	.dbline 140
; 
; //-----------------------------------------------------------------------------
; void Get_Param_168 (BYTE index, BOOL NonVolatile, tParam_168 value)
; {
	.dbline 141
; 	if (NonVolatile)
	cmp [X-5],0
	jz L53
	.dbline 142
; 		cstrncpy (value, NonvolatileP.Param_168[index], 21);
	mov A,0
	push A
	mov A,21
	push A
	mov REG[0xd0],>__r0
	mov A,[X-4]
	mov [__r1],A
	mov A,0
	push A
	mov A,[__r1]
	push A
	mov A,0
	push A
	mov A,21
	push A
	xcall __mul16
	add SP,-4
	mov A,[__rX]
	mov [__r1],A
	mov A,[__rY]
	mov [__r0],A
	add [__r1],<_NonvolatileP+64
	adc [__r0],>_NonvolatileP+64
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[X-7]
	push A
	mov A,[X-6]
	push A
	xcall _cstrncpy
	add SP,-6
	xjmp L54
L53:
	.dbline 144
	mov A,0
	push A
	mov A,21
	push A
	mov REG[0xd0],>__r0
	mov A,[X-4]
	mov [__r1],A
	mov A,0
	push A
	mov A,[__r1]
	push A
	mov A,0
	push A
	mov A,21
	push A
	xcall __mul16
	add SP,-4
	mov A,[__rX]
	mov [__r1],A
	mov A,[__rY]
	mov [__r0],A
	add [__r1],<_VolatileP+13
	adc [__r0],>_VolatileP+13
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[X-7]
	push A
	mov A,[X-6]
	push A
	xcall _strncpy
	add SP,-6
L54:
	.dbline -2
	.dbline 145
; 	else
; 		strncpy (value, VolatileP.Param_168[index], 21);
; }
L52:
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l value -7 pc
	.dbsym l NonVolatile -5 c
	.dbsym l index -4 c
	.dbend
	.area data(ram, con, rel)
	.dbfile ./parameters.c
_VolatileP::
	.word 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.word 0,0,0,0,0
	.byte 0,0,0,0,0,0
	.dbsym e VolatileP _VolatileP X
